%PAKCS1.14 swi7 VARIABLESHARING

:-noSingletonWarnings.
:-noRedefineWarnings.
:-noDiscontiguousWarnings.

:-importModule('Maybe').
:-importModule('Prelude').
:-importModule('RedBlackTree').


:-curryModule('Set').

%%%%%%%%%%%% function types %%%%%%%%%%%%%%%%%%%
:-multifile functiontype/6.
:-dynamic functiontype/6.
functiontype('Set.empty',empty,0,'Set.empty',nofix,'TCons'('RedBlackTree.RedBlackTree',[_G1012245])).
functiontype('Set.null',null,0,'Set.null',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G1021157]),'TCons'('Prelude.Bool',[]))).
functiontype('Set.elem',elem,1,'Set.elem',nofix,'FuncType'(_G1030027,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G1030027]),'TCons'('Prelude.Bool',[])))).
functiontype('Set.insert',insert,0,'Set.insert',nofix,'FuncType'(_G1038987,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G1038987]),'TCons'('RedBlackTree.RedBlackTree',[_G1038987])))).
functiontype('Set.delete',delete,0,'Set.delete',nofix,'FuncType'(_G451012,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G451012]),'TCons'('RedBlackTree.RedBlackTree',[_G451012])))).
functiontype('Set.toList',toList,0,'Set.toList',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G460095]),'TCons'([],[_G460095]))).
functiontype('Set.fromList',fromList,0,'Set.fromList',nofix,'FuncType'('TCons'([],[_G468950]),'TCons'('RedBlackTree.RedBlackTree',[_G468950]))).
functiontype('Set.union',union,1,'Set.union',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G477946]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G477946]),'TCons'('RedBlackTree.RedBlackTree',[_G477946])))).
functiontype('Set.intersect',intersect,2,'Set.intersect',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G487038]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G487038]),'TCons'('RedBlackTree.RedBlackTree',[_G487038])))).
functiontype('Set.disjoint',disjoint,2,'Set.disjoint',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G496127]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G496127]),'TCons'('Prelude.Bool',[])))).

%%%%%%%%%%%% constructor types %%%%%%%%%%%%%%%%%%%
:-multifile constructortype/7.
:-dynamic constructortype/7.

%%%%%%%%%%%% function definitions %%%%%%%%%%%%%%%%%%%
'Set.empty'(_G517269,_G517270,_G517271):-freeze(_G517270,'blocked_Set.empty'(_G517269,_G517270,_G517271)).
'blocked_Set.empty'(_G517427,_G517430,_G517433):-hnf('RedBlackTree.empty'(partcall(2,'Prelude.==',[]),partcall(2,'Prelude.==',[]),partcall(2,'Prelude.<',[])),_G517427,_G517430,_G517433).

'Set.null'(_G518093,_G518094,_G518095):-freeze(_G518094,'blocked_Set.null'(_G518093,_G518094,_G518095)).
'blocked_Set.null'(_G518131,_G518134,_G518137):-hnf(partcall(1,'RedBlackTree.isEmpty',[]),_G518131,_G518134,_G518137).

'Set.elem'(_G518487,_G518488,_G518489,_G518490):-freeze(_G518489,'blocked_Set.elem'(_G518487,_G518488,_G518489,_G518490)).
'blocked_Set.elem'(_G518525,_G518652,_G518655,_G518658):-hnf('Prelude..'(partcall(1,'Maybe.isJust',[]),partcall(1,'RedBlackTree.lookup',[_G518525])),_G518652,_G518655,_G518658).

'Set.insert'(_G519300,_G519301,_G519302):-freeze(_G519301,'blocked_Set.insert'(_G519300,_G519301,_G519302)).
'blocked_Set.insert'(_G519338,_G519341,_G519344):-hnf(partcall(2,'RedBlackTree.update',[]),_G519338,_G519341,_G519344).

'Set.delete'(_G519733,_G519734,_G519735):-freeze(_G519734,'blocked_Set.delete'(_G519733,_G519734,_G519735)).
'blocked_Set.delete'(_G519771,_G519774,_G519777):-hnf(partcall(2,'RedBlackTree.delete',[]),_G519771,_G519774,_G519777).

'Set.toList'(_G520166,_G520167,_G520168):-freeze(_G520167,'blocked_Set.toList'(_G520166,_G520167,_G520168)).
'blocked_Set.toList'(_G520204,_G520207,_G520210):-hnf(partcall(1,'RedBlackTree.tree2list',[]),_G520204,_G520207,_G520210).

'Set.fromList'(_G520644,_G520645,_G520646):-freeze(_G520645,'blocked_Set.fromList'(_G520644,_G520645,_G520646)).
'blocked_Set.fromList'(_G520762,_G520765,_G520768):-hnf(partcall(1,'Prelude.foldr',['Set.empty','Set.insert']),_G520762,_G520765,_G520768).

'Set.union'(_G521282,_G521283,_G521284,_G521285):-freeze(_G521284,'blocked_Set.union'(_G521282,_G521283,_G521284,_G521285)).
'blocked_Set.union'(_G521320,_G521487,_G521490,_G521493):-hnf('Prelude..'(partcall(1,'Prelude.foldr',[_G521320,'Set.insert']),'Set.toList'),_G521487,_G521490,_G521493).

'Set.intersect'(_G522246,_G522247,_G522248,_G522249,_G522250):-freeze(_G522249,'blocked_Set.intersect'(_G522246,_G522247,_G522248,_G522249,_G522250)).
'blocked_Set.intersect'(_G522289,_G522298,_G522658,_G522661,_G522664):-hnf('Prelude.$'('Set.fromList','Prelude.$'(partcall(1,'Prelude.filter',[partcall(1,'Prelude.flip',[_G522298,partcall(1,'Set.elem',[])])]),'Prelude.apply'('Set.toList',_G522289))),_G522658,_G522661,_G522664).

'Set.disjoint'(_G523844,_G523845,_G523846,_G523847,_G523848):-freeze(_G523847,'blocked_Set.disjoint'(_G523844,_G523845,_G523846,_G523847,_G523848)).
'blocked_Set.disjoint'(_G523887,_G523896,_G524056,_G524059,_G524062):-hnf('Prelude.apply'('Set.null','Set.intersect'(_G523887,_G523896)),_G524056,_G524059,_G524062).

:-costCenters(['']).




%%%%% Number of shared variables: 0
